<?php

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 * Description of actions 
 * Es para informe web de webservice de cartera
 *
 * @author Manuel enrique Paredes Lopez
 * @email mparedes@sofhouse.net
 * @fecha 081119
 */
class inf_pag_web_wesActions extends sfActions {
    
    public function executeList(sfWebRequest $request) {
        
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Paginacion
         */
        if (isset($request['_startRow'])) {
            $rowStart = $request['_startRow'];
        } else {
            $rowStart = 0;
        }

        if (isset($request['_endRow'])) {
            $rowEnd = $request['_endRow'];
        } else {
            $rowEnd = 75;
        }

        //ordenar consulta
        if (isset($request['_sortBy'])) {
            $sortBy = " Order by " . $request['_sortBy'];
        } else {
            $sortBy = 'order by tab0.tipo_pago';
        }
        
        /*
         * Manejo de errores
         */
        try {
            //fecha obligatoria
            $fecha_log_ini = $request['fecha_ini'];
            $fecha_log_fin = $request['fecha_fin'];
            //tipo pago
            $whereTipo = " ";
            if (isset($request['tipo']) && $request['tipo'] != '0') {
                $whereTipo = " and tab0.tipo in (" . $request['tipo'] . ")";
            }
            
            //terminoProceso
            $whereTerminoProceso = " ";
            if (isset($request['termino_proceso']) && $request['termino_proceso'] != '0') {
                $whereTerminoProceso = " and tab0.termino_proceso in (" . $request['termino_proceso'] . ")";
            }
            
            
            //tipo pago
            $whereTipoPago = " ";
            if (isset($request['tipo_pago_wes']) && $request['tipo_pago_wes'] != '0') {
                $whereTipoPago = " AND tab0.tipo_pago LIKE '" . $request['tipo_pago_wes']."'";
                
            }
            //tipo_credito
            $whereTipoCredito = " ";
            if (isset($request['id_tipo_credito']) && $request['tipo_credito'] != '0') {
                $whereTipoCredito = " and tab0.id_tipo_credito in (" . $request['id_tipo_credito'] . ")";
            }
            
            //codigo_soporte
            $whereCodigoAux = ' ';
            if (isset($request['codigo_aux'])) {
                $whereCodigoAux = " AND tab0.codigo_aux = " . $request['codigo_aux'];
            }
            
                  //sentencia sql
            $sql = <<<EOD
ALTER SESSION SET NLS_DATE_FORMAT = "YYYY-MM-DD"
EOD;
            //ejecuta y obtiene el resultado del sql
            CN_TABLE::executeSQL($sql);
            
            /*
             * sql que trae los resultados
             * por los filtros, para totalizar las filas
             */
            $sql = <<<EOD
select count(*) as count from (
                    
   SELECT tab0.ID,
       tab0.FECHA_LOG,
       tab0.TIPO,
       tab0.ID_TIPO_CREDITO,             
       case when tab0.ID_TIPO_CREDITO =1 then 'CREDITO' else 'DEBITO' end as tipo_credito,
       case when tab0.TERMINO_PROCESO = 1 then 'Procesado' else 'Sin Procesar' end as TERMINO_PROCESO_LETRA,
       tab0.TERMINO_PROCESO,
       tab0.MOTIVO_ERROR,
       tab0.CODIGO_AUX,
       tab0.OBSERVACIONES,tab0.VALOR,
       tab0.TIPO_PAGO
FROM WEB_PAGOS_VAR_V tab0                    
where   
tab0.fecha_log between to_date('$fecha_log_ini', 'YYYY-MM-DD') and to_date('$fecha_log_fin', 'YYYY-MM-DD') 
$whereTipoPago
$whereTipo
$whereTipoCredito
$whereCodigoAux
$whereTerminoProceso    
) 
EOD;


            $total_record_count = CN_TABLE::executeSQL($sql);
            $total_record_count = $total_record_count[0]["count"];
            
             //obtener el listado de recaudos
            $sql = <<<EOD
select * from ( SELECT row_.*, ROWNUM rownum_ FROM (            
   SELECT tab0.ID,
       tab0.FECHA_LOG,
       tab0.TIPO,
       tab0.ID_TIPO_CREDITO,
       case when tab0.TERMINO_PROCESO = 1 then 'Procesado' else 'Sin Procesar' end as TERMINO_PROCESO_LETRA,
       tab0.TERMINO_PROCESO,
       tab0.MOTIVO_ERROR,
       tab0.CODIGO_AUX,
       tab0.OBSERVACIONES,tab0.VALOR,
       tab0.TIPO_PAGO
FROM WEB_PAGOS_VAR_V tab0                    
where   
tab0.fecha_log between to_date('$fecha_log_ini', 'YYYY-MM-DD') and to_date('$fecha_log_fin', 'YYYY-MM-DD') 
$whereTipoPago
$whereTipo
$whereTipoCredito
$whereCodigoAux
$whereTerminoProceso      
$sortBy

   ) row_ WHERE ROWNUM <=  $rowEnd   ) where rownum_ >  $rowStart

EOD;
            //ejecuta y obtiene el resultado del sql
            $resultado = CN_TABLE::executeSQL($sql);

            $this->totalRows = $total_record_count;
            $this->startRow = $rowStart;
            $this->endRow = $rowStart + count($resultado);
            $this->list_data = $resultado;
            $this->logMessage("[inf_pag_web_wes] Consulta exitosa.");
            
        } catch (Exception $ex) {
            
            $this->status = 1;
            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->list_data = array();
            $this->logMessage("ERROR!!!");
            $this->logMessage($e->getMessage());

        }
    }
    
//put your code here
    /**
     * Metodo para sumar 
     *
     * @param sfWebRequest $request
     */
    public function executeSum(sfWebRequest $request) {
        
        
         //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Paginacion
         */
        if (isset($request['_startRow'])) {
            $rowStart = $request['_startRow'];
        } else {
            $rowStart = 0;
        }

        if (isset($request['_endRow'])) {
            $rowEnd = $request['_endRow'];
        } else {
            $rowEnd = 75;
        }

        //ordenar consulta
        if (isset($request['_sortBy'])) {
            $sortBy = " Order by " . $request['_sortBy'];
        } else {
            $sortBy = 'order by tab0.tipo_pago';
        }
        
        /*
         * Manejo de errores
         */
        try {
            //fecha obligatoria
            $fecha_log_ini = $request['fecha_ini'];
            $fecha_log_fin = $request['fecha_fin'];
            //tipo pago
            $whereTipo = " ";
            if (isset($request['tipo']) && $request['tipo'] != '0') {
                $whereTipo = " and tab0.tipo in (" . $request['tipo'] . ")";
            }
            
            //terminoProceso
            $whereTerminoProceso = " ";
            if (isset($request['termino_proceso']) && $request['termino_proceso'] != '0') {
                $whereTerminoProceso = " and tab0.termino_proceso in (" . $request['termino_proceso'] . ")";
            }
            
            
            //tipo pago
            $whereTipoPago = " ";
            if (isset($request['tipo_pago_wes']) && $request['tipo_pago_wes'] != '0') {
                $whereTipoPago = " AND tab0.tipo_pago LIKE '" . $request['tipo_pago_wes']."'";
                
            }
            //tipo_credito
            $whereTipoCredito = " ";
            if (isset($request['id_tipo_credito']) && $request['tipo_credito'] != '0') {
                $whereTipoCredito = " and tab0.id_tipo_credito in (" . $request['id_tipo_credito'] . ")";
            }
            
            //codigo_soporte
            $whereCodigoAux = ' ';
            if (isset($request['codigo_aux'])) {
                $whereCodigoAux = " AND tab0.codigo_aux = " . $request['codigo_aux'];
            } 
            
            
            
              //obtener el listado de recaudos
            $sql = <<<EOD
select 
'Total: ' || count(*) as id,
SUM(valor) as valor from (            
   SELECT tab0.ID,
       tab0.FECHA_LOG,
       tab0.TIPO,
       tab0.ID_TIPO_CREDITO,
       case when tab0.TERMINO_PROCESO = 1 then 'Procesado' else 'Sin Procesar' end as TERMINO_PROCESO_LETRA,
       tab0.TERMINO_PROCESO,
       tab0.MOTIVO_ERROR,
       tab0.CODIGO_AUX,
       tab0.OBSERVACIONES,
       tab0.VALOR,             
       tab0.TIPO_PAGO
FROM WEB_PAGOS_VAR_V tab0                    
where   
tab0.fecha_log between to_date('$fecha_log_ini', 'YYYY-MM-DD') and to_date('$fecha_log_fin', 'YYYY-MM-DD') 
$whereTipoPago
$whereTipo
$whereTipoCredito
$whereCodigoAux
$whereTerminoProceso      
$sortBy)
EOD;
            
             
            //ejecuta y obtiene el resultado del sql
            $resultado = CN_TABLE::executeSQL($sql);
            

            $this->totalRows = count($resultado);
            $this->startRow = 0;
            $this->endRow = count($resultado);
            $this->list_data = $resultado;
        } catch (Exception $e) {

            $this->status = 1;
            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->list_data = array();
            $this->logMessage("ERROR!!!");
            $this->logMessage($e->getMessage());
        }
        
        
        
    }
    
}
